[LeetCode] 11. Container With Most Water

题目:https://leetcode.com/problems/container-with-most-water/description/

题目

Given n non-negative integers a1a2, ..., an, where each represents a point at coordinate (iai). n vertical lines are drawn such that the two endpoints of line i is at (iai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container and n is at least 2.

Solution


Approach #1 Brute Force [Time Limit Exceeded]

Algorithm

In this case, we will simply consider the area for every possible pair of the lines and find out the maximum area out of those.

Java

class Solution {
    public int maxArea(int[] height) {
        int maxarea = 0;
        for(int i=0;i<height.length;i++)
            for(int j =i+1;j<height.length;j++)
                maxarea = Math.max(maxarea,Math.min(height[i],height[j])*(j-i));
        return maxarea;
    }
}

但这会报错,时间超时。

Approach #2 (Two Pointer Approach) [Accepted]

Algorithm

The intuition behind this approach is that the area formed between the lines will always be limited by the height of the shorter line. Further, the farther the lines, the more will be the area obtained.

We take two pointers, one at the beginning and one at the end of the array constituting the length of the lines. Futher, we maintain a variable maxareamaxarea to store the maximum area obtained till now. At every step, we find out the area formed between them, update maxareamaxarea and move the pointer pointing to the shorter line towards the other end by one step.

The algorithm can be better understood by looking at the example below:

1 8 6 2 5 4 8 3 7

How this approach works?

Initially we consider the area constituting the exterior most lines. Now, to maximize the area, we need to consider the area between the lines of larger lengths. If we try to move the pointer at the longer line inwards, we won't gain any increase in area, since it is limited by the shorter line. But moving the shorter line's pointer could turn out to be beneficial, as per the same argument, despite the reduction in the width. This is done since a relatively longer line obtained by moving the shorter line's pointer might overcome the reduction in area caused by the width reduction.

For further clarification click here and for the proof click here.

Java

class Solution {
    public int maxArea(int[] height) {
        int lnode = 0;
        int rnode = height.length-1;
        int maxarea = 0;
        while(lnode<rnode){
            maxarea = Math.max(maxarea,Math.min(height[lnode],height[rnode])*(rnode - lnode));
            if(height[lnode]<height[rnode]) lnode++;
            else    rnode--;
        }
        return maxarea;
    }
}

Complexity Analysis

  • Time complexity : O(n)O(n). Single pass.

  • Space complexity : O(1)O(1). Constant space is used.





评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值